
vector lhtR;    // kierunek swiatla, dla zgodnosci (tu nie uzywam)
vector lPos;    // pozycja swiatla (we wspolrzednych mesha!)
vector vCPS;    // pozycja kamery (w swiecie)
vector lCol;    // kolor swiatla odbicia (dla dot3s)

matrix mWld;    // World
matrix mTot;    // Total

texture tDif;   // Tekstura glowna
texture tDf3;   // Normal map

vector lAmb;    // kolor ambientu

vector sDir; // sky dir
vector sCol; // sky col


technique tec0
{ 

 pass p1
 {
  AlphaBlendEnable = false;
//  SrcBlend = Zero;
//  DestBlend = SrcColor;
  CullMode=ccw;
  SrcBlend = SrcColor;
  DestBlend = One;
  BlendOp=Add;
  ZBias=0;

  VertexShaderConstant[0] = <mWld>; 	// World Matrix
  VertexShaderConstant[4] = <mTot>;	// World*View*Proj Matrix
  VertexShaderConstant[16] = <sDir>;	// Light direction
  VertexShaderConstant[17] = <sCol>;    // light color
  VertexShaderConstant[18] = <lAmb>;
  vertexShaderConstant[20] = (.5f,.5f,.5f,.5f);
  VertexShaderConstant[21] = <lhtR>;    // sky dir
  VertexShaderConstant[22] = <lCol>;    // sky col
//  VertexShaderConstant[23] = <lPos>;    // light position
  VertexShaderConstant[24] = <vCPS>;

  Texture[0]   = <tDif>;
  Texture[1]   = <tDf3>;

  VertexShader = 
  decl
  {
   stream 0;
   float v0[3]; //Position
   float v3[3]; //Normal
   float v7[2]; //Texture Coord1
   float v8[2]; //Tangent
   float v9[2]; //Tangent
  }
  asm
  {
   vs.1.1
   // Transform position
   m4x4 oPos,v0,c4

   // Transform normal and tangent
   m3x3 r7,v7,c0
   m3x3 r8,v3,c0
            
   // Cross product
   mul r0,-r7.zxyw,r8.yzxw;
   mad r5,-r7.yzxw,r8.zxyw,-r0;

   //
   // licze swiatlo 0
   //
            
   // Transform the light vector
   dp3 r6.x,r7,-c16
   dp3 r6.y,r5,-c16
   dp3 r6.z,r8,-c16
            
   // Multiply by a half to bias, then add half
   mad r6.xyz,r6.xyz,c20,c20
            
   // wynik - swiatlo 0
   mov oD1.xyz, r6.xyz


   //
   // licze swiatlo 1 (sky light plus ambient)
   //

   dp3  r9, r8, -c16    
   mul  r9, r9, c17    
   add r9, r9, c18

   dp3 r10, r8, -c21
   mul r10, r10, c22
   add oD0, r9, r10



   //
   // wspolrzedne tekstur
   //
   mov oT0.xy,v7.xy
   mov oT1.xy,v7.xy
  };

  PixelShader = 
  asm
  {
   ps.1.1
   tex t0 // teksrurka glowna
   tex t1 // normal

   dp3 r0, t1_bx2, v1	// ze swiatlem, nie z v1_bx2
   mul r0, r0, r0
   mul r0, r0, t0

   lrp r0, r0, v0, r0

  }; 	
 }

 pass p2
 {
  AlphaBlendEnable = true;
  SrcBlend = One;
  DestBlend = One;
  BlendOp=Add;
  ZBias=1;


  VertexShaderConstant[0] = <mWld>; 	//World Matrix
  VertexShaderConstant[4] = <mTot>;	//World*View*Proj Matrix
  VertexShaderConstant[9] = (0.6f, 0.8f, 1.0f, 1.0f); // kolor swiatla
  VertexShaderConstant[16] = <sDir>; //kierunek swiatla
  VertexShaderConstant[20] = (.5f,.5f,.5f,.5f);
//  VertexShaderConstant[21] = <lCol>; // kolor swiatla
  VertexShaderConstant[21] = (1.0f, 1.0f, 1.0f, 1.0f); // kolor swiatla
  VertexShaderConstant[23] = <lPos>; // pozycja swiatla
  VertexShaderConstant[24] = <vCPS>; // pozycja kamery

  Texture[0]   = <tDif>;
  Texture[1]   = <tDf3>;

  VertexShader = 
  decl
  {
   stream 0;
   float v0[3]; //Position
   float v3[3]; //Normal
   float v7[2]; //Texture Coord1
   float v8[2]; //Tangent
   float v9[2]; //Tangent
  }   
  asm 
  {
            vs.1.1             
            m4x4 oPos, v0, c4  
            m4x4 r0,v0,c0      
    	    
            add r0,-r0,c24     

            // Normalize
            dp3 r11.x,r0.xyz,r0.xyz   
            rsq r11.xyz,r11.x         
            mul r0.xyz,r0.xyz,r11.xyz 

            add r2.xyz,r0.xyz,-c16    
	
            dp3 r11.x,r2.xyz,r2.xyz   
            rsq r11.xyz,r11.x         
            mul r2.xyz,r2.xyz,r11.xyz 

            m3x3 r1,v3,c0             
        
            dp3  r3.xyzw,r1,r2

            mul r3,r3,r3 //  2nd
            mul r3,r3,r3 //  4th

	    
            dp3 r4,r1,-c16
 	 
            // Blend it in
            mul r3,c20,r3   // Kd
            mul r4,r4,c21   // Ks

            mul r4,r4,c9   // Specular
	 
            mov oD0,r4      
	   
   // teksrurki
   mov oT0.xy, v7.xy
   mov oT1.xy, v7.xy
  };

  PixelShader = 
  asm
  {
   ps.1.1
   tex t0 // tekstura podstawowa
   tex t1 // normal map

//   mov r1, t0.a
   mul r0, v0, t0.a
//   mov r0, v0
//   mul r1,r0,r0; // wyostrzyc
//   mul r0,r1,r1; 
  }; 	
 }

}



technique tec1
{ 
 pass p0
 {
  ZBias=1;
 
  Texture[0] = <tDif>;
 
  ColorOp[0] = Modulate;
		
  ColorArg1[0] = Diffuse;
  ColorArg2[0] = Texture;

  AlphaOp[0]=Disable;

  ColorOp[1]=Disable;
  AlphaOp[1]=Disable;

  PixelShader  = NULL;
  VertexShader = XYZ | Normal | Tex3;
 }

}
